import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
public class GraphWrite extends Frame{
	int posX1[]=new int[100];
	int posY1[]=new int[100];
	int posX2[]=new int[100];
	int posY2[]=new int[100];
	int lineColor[]=new int[100];
	int lineNum=1;
	int curcolor=7;
	boolean drawflag=false;
	Button btn1,btn2,btn3;
	final JFileChooser myFileChooser=new JFileChooser();
	public GraphWrite(String title){
		super(title);
	}
	public static void main(String[] args){
		GraphWrite gwrite=new GraphWrite("graph write");
		gwrite.init();
		gwrite.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
//				this.stop();
//				this.destroy();
				System.exit(0);
			}
		});	
	} 
	public void init(){
		setSize(1000,600);
		setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		btn1=new Button("load");
		btn2=new Button("save");
		btn3=new Button("undo");
		Choice colMenu=new Choice();
		colMenu.addItem("white");
		colMenu.addItem("red");
		colMenu.addItem("blue");
		colMenu.addItem("magenta");
		colMenu.addItem("green");
		colMenu.addItem("cyan");
		colMenu.addItem("yellow");		 
		add(btn1);add(btn2);add(btn3);add(colMenu);
		setVisible(true);
		repaint();
		setBackground(Color.black);
	
		addMouseListener(new MouseAdapter(){
		public void mousePressed(MouseEvent me){
			if(!drawflag){
			if(lineNum<99){lineNum++;}

			posX1[lineNum]=me.getX();
			posY1[lineNum]=me.getY();
//			posX2=me.getX()+100;
//			posY2=me.getY()+100;
			drawflag=true;
		}}
		public void mouseReleased(MouseEvent me){
			if(drawflag){
			posX2[lineNum]=me.getX();
			posY2[lineNum]=me.getY();
			repaint();
			drawflag=false;
			lineColor[lineNum+1]=curcolor;
		}}

		});
		colMenu.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			String choise=(String)e.getItem();
			if(choise.equals("red")){lineColor[lineNum+1]=1;curcolor=1;}
			if(choise.equals("blue")){lineColor[lineNum+1]=2;curcolor=2;}
			if(choise.equals("magenta")){lineColor[lineNum+1]=3;curcolor=3;}
			if(choise.equals("green")){lineColor[lineNum+1]=4;curcolor=4;}
			if(choise.equals("cyan")){lineColor[lineNum+1]=5;curcolor=5;}
			if(choise.equals("yellow")){lineColor[lineNum+1]=6;curcolor=6;}
			if(choise.equals("white")){lineColor[lineNum+1]=7;curcolor=7;}
			}
		});

		btn1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				int intret=myFileChooser.showOpenDialog(
					GraphWrite.this);
				File fname = myFileChooser.getSelectedFile();
		if(intret==JFileChooser.APPROVE_OPTION){
		try{
			FileReader fRead=new FileReader(fname.getAbsolutePath());
			BufferedReader strRead=new BufferedReader(fRead);
			lineNum=strRead.read();
			for(int i=2;i<=lineNum;i++){
				posX1[i]=strRead.read()*8;
				posY1[i]=strRead.read()*8;
				posX2[i]=strRead.read()*8;
				posY2[i]=strRead.read()*8;
				posX1[i]+=strRead.read();
				posY1[i]+=strRead.read();
				posX2[i]+=strRead.read();
				posY2[i]+=strRead.read();
				lineColor[i]=strRead.read();
			}
				lineColor[lineNum+1]=curcolor;

			strRead.close();
			repaint();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}catch(IOException e){
			e.printStackTrace();
		}
		}

			}
		}); 

		btn2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				int intret=myFileChooser.showSaveDialog(
					GraphWrite.this);
			if(intret==JFileChooser.APPROVE_OPTION){
		try{
			File fname = myFileChooser.getSelectedFile();
//			String strFile=(String)fname;
//			if(strFile.indexOf(".")==-1){fname+=".txt";}
			FileWriter fWrite=new FileWriter(fname.getAbsolutePath());
			BufferedWriter strWrite=new BufferedWriter(fWrite);
			strWrite.write(lineNum);
			for(int i=2;i<=lineNum;i++){
				strWrite.write(posX1[i]/8);
				strWrite.write(posY1[i]/8);
				strWrite.write(posX2[i]/8);
				strWrite.write(posY2[i]/8);
				strWrite.write(posX1[i]%8);
				strWrite.write(posY1[i]%8);
				strWrite.write(posX2[i]%8);
				strWrite.write(posY2[i]%8);
				strWrite.write(lineColor[i]);

			}


			strWrite.close();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}catch(IOException e){
			e.printStackTrace();
		}


			}}
		}); 
		btn3.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if(lineNum>=2){lineColor[lineNum]=curcolor;lineNum--;}
				repaint();
			}
		}); 

	}
	public void paint(Graphics g){
		g.setColor(Color.white);
		int i; 
		g.drawString(""+lineNum+""+posX1[lineNum]+""+posY1[lineNum],50,50);
		for(i=2;i<=lineNum;i++){
		if(lineColor[i]==1){g.setColor(Color.red);}
		if(lineColor[i]==2){g.setColor(Color.blue);}
		if(lineColor[i]==3){g.setColor(Color.magenta);}
		if(lineColor[i]==4){g.setColor(Color.green);}
		if(lineColor[i]==5){g.setColor(Color.cyan);}
		if(lineColor[i]==6){g.setColor(Color.yellow);}
		if(lineColor[i]==7){g.setColor(Color.white);}

		N80Graph.N80Line(g,posX1[i]/5,posY1[i]/5,posX2[i]/5,posY2[i]/5);
		}
/*	
		int x=50;
		int y=50;
		N80Graph.N80Line(g,x,y,x+70,y+50);
		N80Graph.N80Line(g,x+50,y+30,x-70,y-50);
		N80Graph.N80Line(g,x+20,y+10,x+50,y+30);
		N80Graph.N80Line(g,x-20,y-20,x+40,y+30);
*/
	}
}